> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pelanor.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create AWS Integration

This endpoint allows you to create an <strong>automatic</strong> integration by generating CloudFormation templates that are executed on the client Billing (Management) and Subaccounts.
Refer to the <a href="/integrations/platform/aws">AWS Integration</a> documentation for more information on how this type of integration works.

Typical Workflow:

<Steps>
  <Step title="Generate Management CloudFormation Template">
    Call this endpoint with the appropriate parameter, to generate the management / billing account CloudFormation template with your Pelanor organization credentials.
  </Step>

  <Step title="Run Management CF">
    Run the generated template in `us-east-1`.
  </Step>

  <Step title="Generate Subaccount CF">
    Call this endpoint with the subaccount CloudFormation parameter, to get the StackSet file to run in order to collect subaccount-related information. Note the <strong>Include Subaccount Bucket</strong> option.
  </Step>

  <Step title="Run Subaccount CF">
    Run the generated template in `us-east-1`.
  </Step>
</Steps>

<Warning>
  The AWS Integration will only appear in the Pelanor platform (and in the List Integrations API) once Pelanor receives data from your AWS integration. This can take up to 48 hours to propagate.
</Warning>


## OpenAPI

````yaml POST /v2/integrations/collectors/aws-cloudformation
openapi: 3.1.0
info:
  title: public/common/filters.proto
  version: version not set
servers:
  - url: https://api.pelanor.io
  - url: https://api-eu.pelanor.io
    description: Production (EU)
security:
  - ApiToken: []
tags:
  - name: QueryService
  - name: ReportExecutionService
  - name: SchemaService
  - name: CustomMetricsService
  - name: DimensionsService
  - name: IntegrationsService
  - name: UsersService
  - name: WorkspaceService
paths:
  /v2/integrations/collectors/aws-cloudformation:
    post:
      tags:
        - IntegrationsService
      summary: Create an AWS CloudFormation template for automatic integration
      operationId: IntegrationsService_GenerateCloudformationTemplate
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/integrationsGenerateCloudformationTemplateRequest
        required: true
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/apiHttpBody'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    integrationsGenerateCloudformationTemplateRequest:
      type: object
      properties:
        mode:
          $ref: '#/components/schemas/GenerateCloudformationTemplateRequestMode'
        workspaceId:
          title: Override the workspace ID that the integration will be created in
          type: string
    apiHttpBody:
      type: object
      properties:
        contentType:
          type: string
          description: >-
            The HTTP Content-Type header value specifying the content type of
            the body.
        data:
          pattern: ^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$
          type: string
          description: The HTTP request/response body as raw binary.
          format: byte
        extensions:
          type: array
          description: >-
            Application specific response metadata. Must be set in the first
            response

            for streaming APIs.
          items:
            $ref: '#/components/schemas/protobufAny'
      description: The CloudFormation template as a string.
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    GenerateCloudformationTemplateRequestMode:
      type: string
      default: MANAGEMENT_ACCOUNT
      enum:
        - MANAGEMENT_ACCOUNT
        - STACKSET_SUBACCOUNT
        - STACKSET_SUBACCOUNT_NO_BUCKET
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties:
        type: object
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
  securitySchemes:
    ApiToken:
      type: http
      scheme: bearer

````